Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 4313)
+++ orxonox/trunk/src/Makefile.am	(revision 4315)
@@ -88,5 +88,4 @@
 		 lib/graphics/particles/particle_system.cc \
 		 lib/graphics/particles/particle_emitter.cc \
-		 lib/lang/base_entity.cc \
 		 lib/lang/base_object.cc \
 		 lib/util/ini_parser.cc \
@@ -158,5 +157,4 @@
 		 lib/graphics/particles/particle_system.h \
 		 lib/graphics/particles/particle_emitter.h \
-		 lib/lang/base_entity.h \
 		 lib/lang/base_object.h \
 		 util/common/list.h \
Index: orxonox/trunk/src/Makefile.in
===================================================================
--- orxonox/trunk/src/Makefile.in	(revision 4313)
+++ orxonox/trunk/src/Makefile.in	(revision 4315)
@@ -73,7 +73,6 @@
 	material.$(OBJEXT) texture.$(OBJEXT) particle_engine.$(OBJEXT) \
 	particle_system.$(OBJEXT) particle_emitter.$(OBJEXT) \
-	base_entity.$(OBJEXT) base_object.$(OBJEXT) \
-	ini_parser.$(OBJEXT) substring.$(OBJEXT) vector.$(OBJEXT) \
-	curve.$(OBJEXT) glmenu_imagescreen.$(OBJEXT) \
+	base_object.$(OBJEXT) ini_parser.$(OBJEXT) substring.$(OBJEXT) \
+	vector.$(OBJEXT) curve.$(OBJEXT) glmenu_imagescreen.$(OBJEXT) \
 	benchmark.$(OBJEXT)
 orxonox_OBJECTS = $(am_orxonox_OBJECTS)
@@ -85,6 +84,5 @@
 @AMDEP_TRUE@	./$(DEPDIR)/animation3d.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/animation_player.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/array.Po ./$(DEPDIR)/base_entity.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/base_object.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/array.Po ./$(DEPDIR)/base_object.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/benchmark.Po ./$(DEPDIR)/camera.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/campaign.Po \
@@ -305,5 +303,4 @@
 		 lib/graphics/particles/particle_system.cc \
 		 lib/graphics/particles/particle_emitter.cc \
-		 lib/lang/base_entity.cc \
 		 lib/lang/base_object.cc \
 		 lib/util/ini_parser.cc \
@@ -375,5 +372,4 @@
 		 lib/graphics/particles/particle_system.h \
 		 lib/graphics/particles/particle_emitter.h \
-		 lib/lang/base_entity.h \
 		 lib/lang/base_object.h \
 		 util/common/list.h \
@@ -472,5 +468,4 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/animation_player.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/array.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/base_entity.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/base_object.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/benchmark.Po@am__quote@
@@ -1276,20 +1271,4 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o particle_emitter.obj `if test -f 'lib/graphics/particles/particle_emitter.cc'; then $(CYGPATH_W) 'lib/graphics/particles/particle_emitter.cc'; else $(CYGPATH_W) '$(srcdir)/lib/graphics/particles/particle_emitter.cc'; fi`
-
-base_entity.o: lib/lang/base_entity.cc
-@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT base_entity.o -MD -MP -MF "$(DEPDIR)/base_entity.Tpo" -c -o base_entity.o `test -f 'lib/lang/base_entity.cc' || echo '$(srcdir)/'`lib/lang/base_entity.cc; \
-@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/base_entity.Tpo" "$(DEPDIR)/base_entity.Po"; else rm -f "$(DEPDIR)/base_entity.Tpo"; exit 1; fi
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='lib/lang/base_entity.cc' object='base_entity.o' libtool=no @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/base_entity.Po' tmpdepfile='$(DEPDIR)/base_entity.TPo' @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o base_entity.o `test -f 'lib/lang/base_entity.cc' || echo '$(srcdir)/'`lib/lang/base_entity.cc
-
-base_entity.obj: lib/lang/base_entity.cc
-@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT base_entity.obj -MD -MP -MF "$(DEPDIR)/base_entity.Tpo" -c -o base_entity.obj `if test -f 'lib/lang/base_entity.cc'; then $(CYGPATH_W) 'lib/lang/base_entity.cc'; else $(CYGPATH_W) '$(srcdir)/lib/lang/base_entity.cc'; fi`; \
-@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/base_entity.Tpo" "$(DEPDIR)/base_entity.Po"; else rm -f "$(DEPDIR)/base_entity.Tpo"; exit 1; fi
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='lib/lang/base_entity.cc' object='base_entity.obj' libtool=no @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/base_entity.Po' tmpdepfile='$(DEPDIR)/base_entity.TPo' @AMDEPBACKSLASH@
-@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o base_entity.obj `if test -f 'lib/lang/base_entity.cc'; then $(CYGPATH_W) 'lib/lang/base_entity.cc'; else $(CYGPATH_W) '$(srcdir)/lib/lang/base_entity.cc'; fi`
 
 base_object.o: lib/lang/base_object.cc
Index: orxonox/trunk/src/class_list.h
===================================================================
--- orxonox/trunk/src/class_list.h	(revision 4315)
+++ orxonox/trunk/src/class_list.h	(revision 4315)
@@ -0,0 +1,96 @@
+/*! 
+    \file class_list.h
+    \brief list of orxonox classes
+
+    this is used by the ObjectManager to identify and load important classes
+*/
+
+
+//! list of all classes to be loadable in via the ObjectManager
+typedef enum classList 
+{
+  CL_CAMERA,
+  CL_ENVIRONEMENT,
+  CL_NPC,
+  CL_PLAYER,
+  CL_POWER_UP,
+  CL_PROJECTILE,
+  CL_SATELLITE,
+  CL_SKYBOX,
+  CL_SKYSPHERE,
+  CL_TERRAIN,
+  CL_TEST_BULLET,
+  CL_TEST_ENTITY,
+  CL_TEST_GUN,
+  CL_WEAPON,
+  CL_WORLD_ENTITY,
+
+  CL_ANIMATION,
+  CL_ANIMATION3D,
+  CL_ANIMATION_PLAYER,
+
+  CL_ARRAY,
+  CL_BASE_OBJECT,
+  CL_BASE,
+
+  CL_NUMBER
+};
+
+/*
+animation.o
+animation3d.o
+animation_player.o
+array.o
+base_entity.o
+base_object.o
+benchmark.o
+camera.o
+campaign.o
+character_attributes.o
+command_node.o
+curve.o
+environment.o
+factory.o
+game_loader.o
+garbage_collector.o
+glmenu_imagescreen.o
+graphics_engine.o
+helper_parent.o
+ini_parser.o
+keynames.o
+light.o
+list.o
+load_param.o
+material.o
+md2Model.o
+model.o
+null_parent.o
+objModel.o
+object_manager.o
+orxonox.o
+p_node.o
+particle_emitter.o
+particle_engine.o
+particle_system.o
+player.o
+primitive_model.o
+projectile.o
+resource_manager.o
+satellite.o
+skybox.o
+skysphere.o
+story_entity.o
+substring.o
+terrain.o
+test_bullet.o
+test_entity.o
+test_gun.o
+text_engine.o
+texture.o
+track_manager.o
+track_node.o
+vector.o
+weapon.o
+world.o
+world_entity.o
+*/
Index: orxonox/trunk/src/lib/lang/base_entity.cc
===================================================================
--- orxonox/trunk/src/lib/lang/base_entity.cc	(revision 4313)
+++ 	(revision )
@@ -1,32 +1,0 @@
-
-
-/* 
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Patrick Boenzli
-   co-programmer: ...
-*/
-
-
-#include "base_entity.h"
-
-
-using namespace std;
-
-
-
-BaseEntity::BaseEntity () {}
-
-
-
-BaseEntity::~BaseEntity () {}
-
-
Index: orxonox/trunk/src/lib/lang/base_entity.h
===================================================================
--- orxonox/trunk/src/lib/lang/base_entity.h	(revision 4313)
+++ 	(revision )
@@ -1,20 +1,0 @@
-/*! 
-  \file base_entity.h
-  \brief This includes the default values every entity should have.						\
-*/
-
-#ifndef _BASE_ENTITY_H
-#define _BASE_ENTITY_H
-
-#include "stdincl.h"
-
-//! The Base of each entity-Class
-class BaseEntity {
-
- public:
-  BaseEntity ();
-  ~BaseEntity ();
-
-};
-
-#endif /* _BASE_ENTITY_H */
Index: orxonox/trunk/src/util/object_manager.h
===================================================================
--- orxonox/trunk/src/util/object_manager.h	(revision 4313)
+++ orxonox/trunk/src/util/object_manager.h	(revision 4315)
@@ -11,5 +11,5 @@
     TO ADD SUPPORT FOR A CLASS do the following steps:
     1. include the hader file : #include "class_header.h"
-    2. add the class to the type enum classList {};
+    2. add the class to the type enum classList {}; in class_list.h
     3. define a function void mCache( ClassName ) in class ObjectManager
 
@@ -24,15 +24,5 @@
 #include "list.h"
 
-#define OM_
-
-
-//! list of all classes to be loadable in via the ObjectManager
-typedef enum classList 
-{
-  CL_PROJECTILE,
-  CL_TEST_BULLET,
-
-  CL_NUMBER
-};
+#include "class_list.h"
   
 