Index: /orxonox/branches/physics/src/lib/graphics/particles/particle_system.cc
===================================================================
--- /orxonox/branches/physics/src/lib/graphics/particles/particle_system.cc	(revision 4335)
+++ /orxonox/branches/physics/src/lib/graphics/particles/particle_system.cc	(revision 4336)
@@ -42,5 +42,5 @@
 ParticleSystem::ParticleSystem (unsigned int maxCount, PARTICLE_TYPE type)
 {
-   this->setClassID(CL_PARTICLE_SYSTEM, "ParticleSystem");
+  this->setClassID(CL_PARTICLE_SYSTEM, "ParticleSystem");
   this->material = NULL;
   this->name = NULL;
@@ -123,12 +123,12 @@
 
   //  glID[0] = glGenLists(count);
-  if (material)
-    delete material;
+  if (this->material)
+    delete this->material;
   material = NULL;
 
-  if (particleType == PARTICLE_SPRITE)
-    {
-      material = new Material("transperencyMap");
-      material->setDiffuseMap("pictures/radialTransparency.png");
+  if (this->particleType == PARTICLE_SPRITE)
+    {
+      this->material = new Material("transperencyMap");
+      this->material->setDiffuseMap("pictures/radialTransparency.png");
       //  material->setTransparency(.5);
     }
Index: /orxonox/branches/physics/src/lib/gui/gui/gui_gtk.cc
===================================================================
--- /orxonox/branches/physics/src/lib/gui/gui/gui_gtk.cc	(revision 4335)
+++ /orxonox/branches/physics/src/lib/gui/gui/gui_gtk.cc	(revision 4336)
@@ -1419,8 +1419,17 @@
 {
   MenuItem* tmpItem = this->firstItem;
-  for (int i = 0; i<this->value; i++)
-    tmpItem = tmpItem->next;
-      
-  return tmpItem->name;
+  for (int i = 0; i < this->value; i++)
+    if (tmpItem)
+      tmpItem = tmpItem->next;
+    else
+      break;
+  if (tmpItem)
+    {
+      char* tmpName = new char[strlen(tmpItem->name)+1];
+      strcpy(tmpName, tmpItem->name);
+      return tmpName;
+    }
+  else 
+    return NULL;
 }
 
@@ -1503,5 +1512,5 @@
 
 #endif /* HAVE_GTK2 */
-  PRINT(5)("%s set to: %d\n", this->title, this->value);
+  PRINT(1)("%s set to: %d\n", this->title, this->value);
 }
 
Index: /orxonox/branches/physics/src/subprojects/Makefile.am
===================================================================
--- /orxonox/branches/physics/src/subprojects/Makefile.am	(revision 4335)
+++ /orxonox/branches/physics/src/subprojects/Makefile.am	(revision 4336)
Index: /orxonox/branches/physics/src/subprojects/particles/particle_fun.cc
===================================================================
--- /orxonox/branches/physics/src/subprojects/particles/particle_fun.cc	(revision 4335)
+++ /orxonox/branches/physics/src/subprojects/particles/particle_fun.cc	(revision 4336)
@@ -44,7 +44,5 @@
 	  break;
 	}
-
-    }
-  
+    }
 }
 
@@ -62,5 +60,6 @@
 void Framework::moduleHelp(void) const
 {
-  PRINT(0)("i - state Information\n\n");
+  PRINT(0)("\n");
+  PRINT(0)("i - Particle-state Information\n\n");
   PRINT(0)("\n");
 
@@ -71,6 +70,5 @@
   Option* option = (Option*) widget;
   const char* name = option->getTitle();
-  char* valueC = option->save();
-  float value = atof(valueC);
+  char* value = option->save();
 
   ParticleEmitter* tmpEmit = ParticleEngine::getInstance()->getEmitterByNumber(1);
@@ -79,34 +77,34 @@
       if (!strcmp(name, "EmissionRate"))
 	{
-	  tmpEmit->setEmissionRate(value);
-	  PRINT(3)("EmissionRate set to %f\n", value);
+	  tmpEmit->setEmissionRate(atof(value));
+	  PRINT(3)("EmissionRate set to %f\n", atof(value));
 	}
       else if (!strcmp(name, "Velocity"))
 	{
-	  tmpEmit->setEmissionVelocity(value);
-	  PRINT(3)("Velocity set to %f\n", value);
+	  tmpEmit->setEmissionVelocity(atof(value));
+	  PRINT(3)("Velocity set to %f\n", atof(value));
 	}
       else if(!strcmp(name, "SpreadAngle"))
 	{
-	  tmpEmit->setSpread(value);
-	  PRINT(3)("SpreadAngle set to %f\n", value);
+	  tmpEmit->setSpread(atof(value));
+	  PRINT(3)("SpreadAngle set to %f\n", atof(value));
 	}
       else if(!strcmp(name, "EmitterType"))
 	{
-	  if (!strcmp(valueC, "EMITTER_DOT"))
+	  if (!strcmp(value, "EMITTER_DOT"))
 	    tmpEmit->setType(EMITTER_DOT);
-	  else if (!strcmp(valueC, "EMITTER_PLANE"))
+	  else if (!strcmp(value, "EMITTER_PLANE"))
 	    tmpEmit->setType(EMITTER_PLANE);
-	  else if (!strcmp(valueC, "EMITTER_CUBE"))
+	  else if (!strcmp(value, "EMITTER_CUBE"))
 	    tmpEmit->setType(EMITTER_CUBE);
-	  PRINT(3)("EmitterType set to %s\n", valueC);	  
+	  PRINT(3)("EmitterType set to %s\n", value);
 	}
       else if(!strcmp(name, "EmitterSize"))
 	{
-	  tmpEmit->setSize(value);
-	  PRINT(3)("EmitterSize set to %f\n", value);
-	}
-    }
-  delete valueC;
+	  tmpEmit->setSize(atof(value));
+	  PRINT(3)("EmitterSize set to %f\n", atof(value));
+	}
+    }
+  delete value;
 }
 
@@ -116,6 +114,6 @@
   Option* option = (Option*) widget;
   const char* name = option->getTitle();
-  char* valueC = option->save();
-  float value = atof(valueC);
+  char* value = option->save();
+  printf("%s\n", value);
 
   ParticleSystem* tmpSys = ParticleEngine::getInstance()->getSystemByNumber(1);
@@ -124,45 +122,45 @@
       if (!strcmp(name, "StartRadius"))
 	{
-	  tmpSys->setRadius(value, tmpSys->getEndRadius());
-	  PRINT(3)("ParticleStartRadius set to %f\n", value);
+	  tmpSys->setRadius(atof(value), tmpSys->getEndRadius());
+	  PRINT(3)("ParticleStartRadius set to %f\n", atof(value));
 	}
       else if (!strcmp(name, "EndRadius"))
 	{
-	  tmpSys->setRadius( tmpSys->getStartRadius(), value);
-	  PRINT(3)("ParticleEndRadius set to %f\n", value);
+	  tmpSys->setRadius( tmpSys->getStartRadius(), atof(value));
+	  PRINT(3)("ParticleEndRadius set to %f\n", atof(value));
 	}
 
       else if (!strcmp(name, "LifeSpan"))
 	{
-	  tmpSys->setLifeSpan(value);
-	  PRINT(3)("ParticleLifeSpan set to %f\n", value);
+	  tmpSys->setLifeSpan(atof(value));
+	  PRINT(3)("ParticleLifeSpan set to %f\n", atof(value));
 	}
 
       else if (!strcmp(name, "ConserveFactor"))
 	{
-	  tmpSys->setConserve(value);
-	  PRINT(3)("ParticleConserveFactor set to %f\n", value);
+	  tmpSys->setConserve(atof(value));
+	  PRINT(3)("ParticleConserveFactor set to %f\n", atof(value));
 	}
 
       else if (!strcmp(name, "ParticleType"))
 	{
-	  if (!strcmp(valueC, "PARTICLE_DOT"))
+	  if (!strcmp(value, "PARTICLE_DOT"))
 	    tmpSys->setType(PARTICLE_DOT);
-	  else if (!strcmp(valueC, "PARTICLE_SPARK"))
+	  else if (!strcmp(value, "PARTICLE_SPARK"))
 	    tmpSys->setType(PARTICLE_SPARK);
-	  else if (!strcmp(valueC, "PARTICLE_SPRITE"))
+	  else if (!strcmp(value, "PARTICLE_SPRITE"))
 	    tmpSys->setType(PARTICLE_SPRITE);
 
-	  PRINT(3)("ParticleType set to %s\n", valueC);
+	  PRINT(3)("ParticleType set to %s\n", value);
 	}
 
       else if (!strcmp(name, "InheritSpeed"))
 	{
-	  tmpSys->setInheritSpeed(value);
-	  PRINT(3)("ParticleInheritSpeed set to %f\n", value);
-	}
-
-    }
-  delete valueC;
+	  tmpSys->setInheritSpeed(atof(value));
+	  PRINT(3)("ParticleInheritSpeed set to %f\n", atof(value));
+	}
+
+    }
+  delete value;
 }
 